#ifndef	_IO_H_
#define	_IO_H_


extern void initio(void);
extern void cmt1_init(int start,int freq);
//extern void INT_CMT1_CMI1(void);	// int_cmi1 (void)	// 荞ݏ֐
extern int sysinit(void);
extern char chkxy(char zz,int zrr);
extern char chky(char zz,int zrr);
extern char chkz(char zz,int zrr);
extern void uWait(long);
extern void wait(long);
extern int PrmRead32(int dispon);
extern int ROMinit(int);
extern int PrmWrite32(void);

//extern CMDin(int, unsigned short, unsigned short,int *,int *);
extern int CMDin(int Serial, unsigned short cmdold, unsigned short mask,int *Adr,int *Data);
extern int conv(char *buf,int size,int *ret,int hex);
extern int opow10(int a);
extern char convax(char chr);
extern int Swin(int mask);	//Conversion CMD
extern int swscan(int mask);
extern int swscansub(int mask);
extern int CheckMNTSW(int mntmode);
extern void emgchk(void);
extern int pos3set(int pos);
extern int	chkp3rdyoff(void);
extern int chkp3rdyon(void);
extern void dump(unsigned int adr,int retu);

#define	PRMMAX	42		//0x2A
typedef struct{
	int	prm[PRMMAX];
} _prm;
//struct _prm	prmr;
extern volatile long TimerCount;		// 1msJE^l
extern volatile char	EMGSTOP;		//~
extern volatile int	StagePos;	//Stage Position
extern _prm	prmr;

#define	TMP1	prmr.prm[0]		//	
#define	TMP2	prmr.prm[1]		//	
#define	TMP3	prmr.prm[2]		//	
#define	STGSEN	prmr.prm[3]		//	Xe[WZT͌̑҂
#define	UVSEN	prmr.prm[4]		//	tuZT͌̑҂
#define	STGCYL	prmr.prm[5]		//	Xe[WV_^CAEg
#define	UVCYL	prmr.prm[6]		//	tuV_^CAEg
#define	UVTOUT	prmr.prm[7]		//	tuƎˎԃ^CAEg
#define	XFL		prmr.prm[8]		//	XNg(PPS)
#define	XFH		prmr.prm[9]		//	Xōg(PPS)
#define	XRR		prmr.prm[10]	//	X[g ő(FH-FL) ŏ0
#define	XOFS	prmr.prm[11]	//	X ORG OFFSET
#define	YFL		prmr.prm[12]	//	YNg(PPS)
#define	YFH		prmr.prm[13]	//	Yōg(PPS)
#define	YRR		prmr.prm[14]	//	Y[g ő(FH-FL) ŏ0
#define	YOFS	prmr.prm[15]	//	Y ORG OFFSET
#define	ZFL		prmr.prm[16]	//	ZNg(PPS)
#define	ZFH		prmr.prm[17]	//	Zōg(PPS)
#define	ZRR		prmr.prm[18]	//	Z[g ő(FH-FL) ŏ0
#define	ZOFS	prmr.prm[19]	//	Z ORG OFFSET
#define	WFL		prmr.prm[20]	//	ZNg(PPS)
#define	WFH		prmr.prm[21]	//	Zōg(PPS)
#define	WRR		prmr.prm[22]	//	Z[g ő(FH-FL) ŏ0
#define	WOFS	prmr.prm[23]	//	Z ORG OFFSET
#define	XDIR	prmr.prm[24]	//	w
#define	YDIR	prmr.prm[25]	//	x
#define	ZDIR	prmr.prm[26]	//	y
#define	WDIR	prmr.prm[27]	//	v
#define	JOGXY	prmr.prm[28]	//	jogpXXY
#define	JOGZ	prmr.prm[29]	//	jogpXZ
#define	XNORG	prmr.prm[30]	//	YORG Near point
#define	YNORG	prmr.prm[31]	//	YORG Near point
#define	ZNORG	prmr.prm[32]	//	ZORG Near point
#define	WNORG	prmr.prm[33]	//	WORG Near point
#define	ORGNP	prmr.prm[34]	//	_ߖTpX
#define	ZSAVE	prmr.prm[35]	//	Zޔʒu
#define	XOFS2	prmr.prm[36]	//	X ORG OFFSET 2
#define	YOFS2	prmr.prm[37]	//	Y ORG OFFSET 2
#define	ZOFS2	prmr.prm[38]	//	Z ORG OFFSET 2
#define	XOFS3	prmr.prm[39]	//	X ORG OFFSET 3
#define	YOFS3	prmr.prm[40]	//	Y ORG OFFSET 3
#define	ZOFS3	prmr.prm[41]	//	Z ORG OFFSET 3
#define	ATMP1	0x0		//0	
#define	ATMP2	0x2		//1	
#define	ATMP3	0x4		//2	
#define	ASTGSEN	0x6		//3	Xe[WZT͌̑҂
#define	AUVSEN	0x8		//4	tuZT͌̑҂
#define	ASTGCYL	0xa		//5	Xe[WV_^CAEg
#define	AUVCYL	0xc		//6	tuV_^CAEg
#define	AUVTOUT	0xe		//7	tuƎˎԃ^CAEg
#define	AXFL	0x10	//8	XNg(PPS)
#define	AXFH	0x12	//9	Xōg(PPS)
#define	AXRR	0x14	//0	X[g ő(FH-FL) ŏ0
#define	AXOFS	0x16	//1	X ORG OFFSET
#define	AYFL	0x18	//2	YNg(PPS)
#define	AYFH	0x1a	//3	Yōg(PPS)
#define	AYRR	0x1c	//4	Y[g ő(FH-FL) ŏ0
#define	AYOFS	0x1e	//5	Y ORG OFFSET
#define	AZFL	0x20	//6	ZNg(PPS)
#define	AZFH	0x22	//7	Zōg(PPS)
#define	AZRR	0x24	//8	Z[g ő(FH-FL) ŏ0
#define	AZOFS	0x26	//9	Z ORG OFFSET
#define	AWFL	0x28	//0	WNg(PPS)
#define	AWFH	0x2a	//1	Wōg(PPS)
#define	AWRR	0x2c	//2	W[g ő(FH-FL) ŏ0
#define	AWOFS	0x2e	//3	W ORG OFFSET
#define	AXDIR	0x30	//4	w
#define	AYDIR	0x32	//5	x
#define	AZDIR	0x34	//6	y
#define	AWDIR	0x36	//7	v
#define	AJOGXY	0x38	//8	jogpXXY
#define	AJOGZ	0x3a	//9	jogpXZ
#define	AXNORG	0x3c	//0	YORG Near point
#define	AYNORG	0x3e	//1	YORG Near point
#define	AZNORG	0x40	//2	ZORG Near point
#define	AWNORG	0x42	//3	WORG Near point
#define	AORGNP	0x44	//4	_ߖTpX
#define	AZSAVE	0x46	//5	Zޔʒu
#define	AXOFS2	0x48	//6	X ORG OFFSET 2
#define	AYOFS2	0x4a	//7	Y ORG OFFSET 2
#define	AZOFS2	0x4c	//8	Z ORG OFFSET 2
#define	AXOFS3	0x4e	//9	X ORG OFFSET 3
#define	AYOFS3	0x50	//0	Y ORG OFFSET 3
#define	AZOFS3	0x51	//1	Z ORG OFFSET 3


//SWBOX	4bit OUT@4bit IN
#define	SWINOUT	PB.DR.BYTE.L	//SWINOUT


#endif	//_IO_H_

